
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>SQL Server 中 EXEC 与 SP_EXECUTESQL 的区别 / iVAN</title>

    <meta name="description" content="SQL Server 中 EXEC 与 SP_EXECUTESQL 的区别 原文:SQL Server 中 EXEC 与 SP_EXECUTESQL 的区别 MSSQL为我们提供了两种动态执行SQL语句的命令,分别是 EXEC 和 SP_EXECUTESQL ,我们先来看一下两种方式的用法. 先建立一个表,并添加一些数据来进行演示: CREATE TABLE t_student( Id INT NOT NULL, Name NVARCHAR (10) NULL, Age TINYINT NULL, School NVARCHAR(20) NULL, Class NVAR">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">SQL Server 中 EXEC 与 SP_EXECUTESQL 的区别</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>原文:<a href="http://www.cnblogs.com/lxblog/archive/2013/01/14/2859828.html" rel="external nofollow noreferrer">SQL Server 中 EXEC 与 SP_EXECUTESQL 的区别</a><br />
<br />MSSQL为我们提供了两种动态执行SQL语句的命令，分别是 EXEC 和 SP_EXECUTESQL ，我们先来看一下两种方式的用法。</p>
<p>先建立一个表，并添加一些数据来进行演示：</p>
<pre>CREATE TABLE t_student(
 Id INT NOT NULL,
 Name NVARCHAR (10) NULL,
 Age TINYINT NULL,
 School NVARCHAR(20) NULL,
 Class NVARCHAR(10) NULL,
 Score FLOAT NULL,
 CONSTRAINT [PK_Student_Id] PRIMARY KEY CLUSTERED(Id)
)
GO

INSERT INTO t_student VALUES(1,'张小红',8,'育才小学','一班',92)
INSERT INTO t_student VALUES(2,'王丽丽',8,'育才小学','一班',90)
INSERT INTO t_student VALUES(3,'张燕',7,'云华小学','二班',86)
INSERT INTO t_student VALUES(4,'刘华',6,'云华小学','二班',85)</pre>
<p>一、EXEC </p>
<p>EXEC命令可以执行一个存储过程也可以执行一个动态SQL语句。先来看看怎么<strong>执行存储过程：</strong></p>
<p>新建一个存储过程 SP_GetStudent ，返回 成绩大于90 分的学生：</p>
<pre>CREATE PROCEDURE [dbo].[Sp_GetStudent]
    @Score FLOAT,
    @Nums INT OUTPUT
AS
BEGIN
    SET NOCOUNT ON;
    SELECT * FROM t_student WHERE Score &gt;=@Score
    SELECT @Nums=COUNT(1) FROM t_student WHERE Score &gt;=@Score
    IF(@Nums&gt;0)
     RETURN 1
    ELSE
     RETURN 0
END
GO</pre>
<p> 该存储过程涉及了 查询操作、返回值和输出参数，我们来看用EXEC 命令如何调用：</p>
<pre>DECLARE @return_value int,
        @OutNums int

EXEC    @return_value = [dbo].[Sp_GetStudent]
        @Score = 90,
        @Nums = @OutNums OUTPUT

SELECT  @OutNums as N'大于90分的人数'

SELECT  '返回值' = @return_value
GO</pre>
<p> 执行结果：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19lZjZkOWFiNDc4Y2VjZmVhMWQ1ZTA2OWJlOGIyYWMyZS5qcGc=.jpg"></p>
<p>我们发现EXEC 执行存储过程和我们平时程序执行一个方法是几乎一样的，返回值参数 直接就可以等于存储过程的执行后的返回值，输出参数 在后面需要增加 OUTPUT 关键字。</p>
<p>执行存储过程不是重点，重点是<strong>执行动态sql语句，同样看一下例子</strong>：</p>
<pre>DECLARE @TableName NVARCHAR(50),@Sql NVARCHAR(MAX),@Score INT;
SET @TableName = 't_Student';
SET @Score = 90;
SET @sql = 'SELECT * FROM '+QUOTENAME(@TableName) +'WHERE Score &gt;= '+CAST(@Score AS NVARCHAR(10))
EXEC (@sql);</pre>
<p> 执行结果：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xZDFmN2VmZmQ1ZDMyZmZlM2UwZjdlZDI0YTE0ZmQ2MS5qcGc=.jpg"></p>
<p>注意：在执行拼接SQL 语句的时候，的EXEC括号中只允许包含一个字符串变量，但是可以串联多个变量，如果我们直接执行这个SQL语句：</p>
<pre>--这是错误的调用
EXEC ('SELECT * FROM '+QUOTENAME(@TableName) +'WHERE Score &gt;= '+CAST(@Score AS NVARCHAR(10)));</pre>
<p> 执行就会提示错误。但是这样就没有问题：</p>
<pre>DECLARE @TableName NVARCHAR(50),@Sql NVARCHAR(MAX),@Score INT
DECLARE @Sql2 NVARCHAR(MAX)
SET @TableName = 't_Student';
SET @Score = 90;
SET @sql = 'SELECT * FROM '+QUOTENAME(@TableName)
SET @Sql2=' WHERE Score &gt;= '+CAST(@Score AS NVARCHAR(10))
EXEC (@sql+@sql2)</pre>
<p> <strong>EXEC 执行拼接sql语句的时候不支持 嵌入式参数，如下：</strong></p>
<pre>DECLARE @OUT_Nums INT,@IN_Score INT,@Sql NVARCHAR(MAX)
SET @IN_Score = 90
SET @sql = 'SELECT @Nums=COUNT(1) FROM t_student WHERE Score &gt;= @Score'
EXEC (@sql)</pre>
<p> <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18wZGMyNTVjN2RlMDM1YTYwZTBkZGVjYzZkM2Q1OWI3Ny5qcGc=.jpg"></p>
<p>通过上面的代码发现，EXEC 执行拼接的SQL语句的时候，不支持内嵌参数，包括输入参数和输出参数。有的时候我们想把得到的count(*)传出来，用EXEC是不好办到的。接下来，再来看看SP_EXECUTESQL的使用：</p>
<p>二、SP_EXECUTESQL：</p>
<p>SP_EXECUTESQL 是在 SQL 2005中引入的新的系统存储过程，也是用来处理动态SQL 语句的。它比EXEC 更加灵活，首先也执行一下第一次的拼接SQL语句：</p>
<pre>DECLARE @TableName NVARCHAR(50),@Sql NVARCHAR(MAX),@Score INT;
SET @TableName = 't_Student';
SET @Score = 90;
SET @sql = 'SELECT * FROM '+QUOTENAME(@TableName) +'WHERE Score &gt;= '+CAST(@Score AS NVARCHAR(10))
EXEC SP_EXECUTESQL @sql --注意这里没有了()</pre>
<p>执行结果：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18xZDFmN2VmZmQ1ZDMyZmZlM2UwZjdlZDI0YTE0ZmQ2MS5qcGc=.jpg"></p>
<p><strong>SP_EXECUTESQL 支持内嵌参数：</strong></p>
<p>先来看一下SP_EXECUTESQL的语法：</p>
<pre><strong>sp_executesql </strong>[ <strong>@stmt = </strong>] <em>stmt</em>
[
  <strong>  </strong>{<strong>, </strong>[<strong>@params=</strong>] <strong>N'@</strong><em>parameter_name data_type </em>[ OUT | OUTPUT ][<strong>,</strong>...<em>n</em>]<strong>' </strong>}
     {<strong>,</strong> [ <strong>@</strong><em>param1</em><strong> = </strong>] <strong>'</strong><em>value1</em><strong>' </strong>[ <strong>,</strong>...<em>n </em>] }
]

说明：[ <strong>@stmt = </strong>] stmt 包含 Transact-SQL 语句或批处理的 Unicode 字符串。stmt 必须是 Unicode 常量或 Unicode 变量。不允许使用更复杂的 Unicode 表达式（例如使用 + 运算符连接两个字符串）。不允许使用字符常量。如果指定了 Unicode 常量，则必须使用 <strong>N</strong> 作为前缀。例如，Unicode 常量 <strong>N'sp_who'</strong> 是有效的，但是字符常量 <strong>'sp_who'</strong> 则无效。字符串的大小仅受可用数据库服务器内存限制。在 64 位服务器中，字符串大小限制为 2 GB，即 <strong>nvarchar(max)</strong> 的最大大小。<strong>stmt 中包含的每个参数在 @params 参数定义列表和参数值列表中均必须有对应项

</strong>[ <strong>@params = </strong>] <strong>N'@</strong>parameter_namedata_type[ <strong>,</strong>... n ] <strong>' </strong>包含 stmt 中嵌入的所有参数定义的字符串。字符串必须是 Unicode 常量或 Unicode 变量。每个参数定义由参数名称和数据类型组成。n 是表示附加参数定义的占位符。在 stmt 中指定的每个参数必须在 <strong>@params</strong> 中定义。如果 stmt 中的 Transact-SQL 语句或批处理不包含参数，则不需要 <strong>@params</strong>。该参数的默认值为 NULL。

[ <strong>@</strong>param1<strong> = </strong>] <strong>'</strong>value1<strong>' </strong></pre>
<p>参数字符串中定义的第一个参数的值。该值可以是 Unicode 常量，也可以是 Unicode 变量。必须为 stmt 中包含的每个参数提供参数值。如果 stmt 中的 Transact-SQL 语句或批处理没有参数，则不需要这些值。</p>
<p> </p>
<pre>[ OUT | OUTPUT ]</pre>
<p>指示参数是输出参数。除非是公共语言运行 (CLR) 过程，否则 <strong>text</strong>、<strong>ntext</strong> 和 <strong>image</strong> 参数均可用作 OUTPUT 参数。使用 OUTPUT 关键字的输出参数可以为游标占位符，CLR 过程除外。</p>
<p> </p>
<p> </p>
<pre>n 附加参数值的占位符。这些值只能为常量或变量，不能是很复杂的表达式（例如函数）或使用运算符生成的表达式。

<strong>返回代码值 :</strong> </pre>
<p>0（成功）或非零（失败）</p>
<p> </p>
<p> </p>
<p> </p>
<p><strong>结果集：</strong>从生成 SQL 字符串的所有 SQL 语句返回结果集</p>
<p> </p>
<p>看不懂没有关系，通过例子就会非常明白的，依旧还执行上面的 SQL 语句：</p>
<pre>DECLARE @OUT_Nums INT,@IN_Score INT,@Sql NVARCHAR(MAX)
SET @IN_Score = 90
SET @sql = 'SELECT @Nums=COUNT(1) FROM t_student WHERE Score &gt;= @Score'
EXEC SP_EXECUTESQL @sql,N'@Nums INT OUT,@Score INT',@OUT_Nums OUTPUT,@IN_Score
SELECT @OUT_Nums AS '人数'</pre>
<p> 执行结果：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18zZDIyZTFiNzg2NTFlZjY0Y2YyY2EwOWJiMDRkYjgzNS5qcGc=.jpg"></p>
<p>需要注意的是：</p>
<p>1、要求动态Sql和动态Sql参数列表必须是NVARCHAR</p>
<p>2、动态Sql的参数列表与外部提供值的参数列表顺序必需一致</p>
<p>3、一旦使用了 '@name = value' 形式之后，所有后续的参数就必须以 '@name = value' 的形式传递，比如：</p>
<pre>DECLARE @OUT_Nums INT,@IN_Score INT,@Sql NVARCHAR(MAX)
SET @IN_Score = 90
SET @sql = 'SELECT @Nums=COUNT(1) FROM t_student WHERE Score &gt;= @Score'
EXEC SP_EXECUTESQL @stmt=@sql,@params=N'@Nums INT OUT,@Score INT',@Nums=@OUT_Nums OUTPUT,@Score=@IN_Score
SELECT @OUT_Nums AS '人数'</pre>
<p>通过上面的例子已经很清晰的表明了，在执行动态SQL 语句的时候，EXEC 和  SP_EXECUTESQL 的区别了，来总结一下：</p>
<p>1、 性能：</p>
<p>官方描述：<strong>sp_executesql</strong> <em>stmt</em> 参数中的 Transact-SQL 语句或批处理在执行 <strong>sp_executesql</strong> 语句时才编译。随后，将编译 <em>stmt</em> 中的内容，并将其作为执行计划运行。该执行计划独立于名为 <strong>sp_executesql</strong> 的批处理的执行计划。<strong>sp_executesql</strong> 批处理不能引用调用 <strong>sp_executesql</strong> 的批处理中声明的变量。<strong>sp_executesql</strong> 批处理中的本地游标或变量对调用 <strong>sp_executesql</strong> 的批处理是不可见的。对数据库上下文所做的更改只在 <strong>sp_executesql</strong> 语句结束前有效。如果只更改了语句中的参数值，则 <strong>sp_executesql</strong> 可用来代替存储过程多次执行 Transact-SQL 语句。因为 Transact-SQL 语句本身保持不变，仅参数值发生变化，所以 SQL Server 查询优化器可能重复使用首次执行时所生成的执行计划。</p>
<p>说通俗一点就是：如果用 EXEC 执行一条动态 SQL 语句，由于每次传入的参数不一样，所以每次生成的 @sql 就不一样，这样每执行一次SQL SERVER 就必须重新将要执行的动态 Sql 重新编译一次 。但是SP_EXECUTESQL 则不一样，由于将数值参数化，要执行的动态 Sql 永远不会变化，只是传入的参数的值在变化，那每次执行的时候就不用重新编译，速度和效率自然有所提升。</p>
<p>2、从上面的例子我们已经能够看出 SP_EXECUTESQL 命令比 EXEC 命令更灵活，因为它提供一个接口，该接口及支持输入参数也支持输出参数。</p>
<p>3、EXEC 执行纯动态SQL，执行时可能无法使用预编译的执行计划，关键是不安全，可以导致 SQL 注入 ，而 SP_EXECUTESQL 执行参数化动态 SQL ,执行时能使用预编译的执行计划，而且保存存储过程时就可以确定可以使用的预编译的执行计划，而且最重要的是“安全”，天然免疫SQL 注入</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 13:50:20</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%ad%98%e5%82%a8%e8%bf%87%e7%a8%8b/" title="存储过程">存储过程</a>, <a href="https://www.iamivan.net/tag/sql/" title="sql">sql</a>, <a href="https://www.iamivan.net/tag/server/" title="server">server</a>, <a href="https://www.iamivan.net/tag/%e8%a1%a8%e8%be%be%e5%bc%8f/" title="表达式">表达式</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>SQL Server 中 EXEC 与 SP_EXECUTESQL 的区别的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9xAl3b.html" rel="bookmark">SQL Server中clustered与nonclustered的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				        CLUSTERED :聚集索引.非聚集索引:NONCLUSTERED.         clustered是物理上实现数据排序,并且同一个表里只能有一个clustered索引,而nonclustered是逻辑上的排序.         微软的SQL Server 支持两种类型的索引:clustered 索引和nonclustered索引.         Clustered索引在数据表中按照物理顺序存储数据.因为在表中只有一个物理顺序,所以在每个表中只能有一个clustered索			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo6e5Bz.html" rel="bookmark">sql server中Select count&lpar;&ast;&rpar;和Count&lpar;1&rpar;的区别和执行方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				    在SQL Server中Count(*)或者Count(1)或者Count([列])或许是最常用的聚合函数.很多人其实对这三者之间是区分不清的.本文会阐述这三者的作用,关系以及背后的原理.     往常我经常会看到一些所谓的优化建议不使用Count(* )而是使用Count(1),从而可以提升性能,给出的理由是Count( *)会带来全表扫描.而实际上如何写Count并没有区别.     Count(1)和Count(*)实际上的意思是,评估Count()中的表达式是否为NULL,如果为			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z403JYz.html" rel="bookmark">在sql server中truncate、delete、drop删除表的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 在sql server中truncate.delete.drop删除表的区别 请详细的说一下truancate和delete在删除表的时候有什么区别,除了(truncate删除表后不能回滚,delete可以回滚:truncate删除的数据不会产生日志记录,delete删除的数据会产生日志记录:truncate直接删除全部的数据,delete可以加上where条件删除部分数据:truncate效率高,delete效率低:)这些之外还有别的吗? 解决方案 truncate不需要检索数据容易			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj2ladb.html" rel="bookmark">SQL SERVER中强制类型转换cast和convert的区别详解&lowbar;MsSql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				SQL SERVER中强制类型转换cast和convert的区别 在SQL SERVER中,cast和convert函数都可用于类型转换,其功能是相同的, 只是语法不同. cast一般更容易使用,convert的优点是可以格式化日期和数值. select CAST('123' as int) -- 123 select CONVERT(int, '123') -- 123 select CAST(123.4 as int) -- 123 select CONVERT(int, 123.4) --			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgyGmAz.html" rel="bookmark">sql server中Select count&lpar;&ast;&rpar;和Count&lpar;1&rpar;的区别和执行方式&lowbar;MsSql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				    在SQL Server中Count(*)或者Count(1)或者Count([列])或许是最常用的聚合函数.很多人其实对这三者之间是区分不清的.本文会阐述这三者的作用,关系以及背后的原理.     往常我经常会看到一些所谓的优化建议不使用Count(* )而是使用Count(1),从而可以提升性能,给出的理由是Count( *)会带来全表扫描.而实际上如何写Count并没有区别.     Count(1)和Count(*)实际上的意思是,评估Count()中的表达式是否为NULL,如果为			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pX2qDAb.html" rel="bookmark">SQL SERVER中强制类型转换cast和convert的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在SQL SERVER中,cast和convert函数都可用于类型转换,其功能是相同的, 只是语法不同. cast一般更容易使用,convert的优点是可以格式化日期和数值. 代码 select CAST('123' as int)   -- 123select CONVERT(int, '123')  -- 123 select CAST(123.4 as int)   -- 123select CONVERT(int, 123.4)  -- 123  select CAST('123.4' 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBZKyJb.html" rel="bookmark">SQL Server中的Image数据类型的操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:SQL Server中的Image数据类型的操作 准备工作,在库Im_Test中建立一张表Im_Info,此表中有两个字段,分别为Pr_Id (INT),Pr_Info (IMAGE),用来存储图形编号及图形信息.其语法如下: CREATE TEALE Im_Info ( Pr_Id INT NULL , Pr_Info IMAGE NULL )  第一步: 往表中插入一条记录,并初始化PR_INFO字段.其语法如下: INSERT INTO Im_Info VALUES (1 ,0xFF			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1N29op.html" rel="bookmark">ms sql server中存储过程入门教程详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.存储过程的概念 T-SQl和C语言一样 ,是一门结构化的语言. 什么是存储过程? 存储过程是SQL查询语句与控制流程语句的预编译集合,并以特定的名称保存在数据库中.存储过程也是数据库对象 分类: 系统存储过程: 以sp_或xp_打头 用户自定义  :以proc_打头 存储过程的优点: 执行速度快 效率高 模块式编程  减少网络流量     提高安全性 二.系统存储过程 SQl server 的系统存储过程保存在master数据库中,且所有命名的系统存储过程命名以&quot;Sp_&quot;开头.在m			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boL1mVM.html" rel="bookmark">SQL Server中授予用户查看对象定义的权限</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				SQL Server中授予用户查看对象定义的权限   在SQL Server中,有时候需要给一些登录名(用户)授予查看所有或部分对象(存储过程.函数.视图.表)的定义权限存.如果是部分存储过程.函数.视图授予查看定义的权限,那么就像下面脚本所示,比较繁琐:     GRANT VIEW DEFINITION ON  YOUR_PROCEDURE TO   USERNAME;   GRANT VIEW DEFINITION ON  YOUR_FUNCTION TO USERNAME;   GRAN			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlvXNz.html" rel="bookmark" class="title">初学入门：详细学习掌握JSP的语法知识</a>
					<div>
						js|初学|语法 HTML 注释 在客户端显示一个注释.  JSP 语法 &lt;!-- comment [ &lt;%= expression %&gt; ] --&gt; 例子 1 &lt;!-- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbE1P9b.html" rel="bookmark" class="title">通过禁用NTbios来优化TMG解析性能</a>
					<div>
						在TMG注册表里修改如下值来禁用NTbios,优化TMG解析性能 Path: HKEY_LOCAL_MACHINE\System\CurrentControlSet\Services\NetBT Pa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxj6Kb.html" rel="bookmark" class="title">ASP&period;NET 窗体间传值实现方法</a>
					<div>
						 假设ParentForm.aspx 页面上有TextBox1文本框和Open按钮 点击Open按钮弹出SubForm.aspx,SubForm.aspx页面上有TextBox1文本框和Close按钮 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLPrOb.html" rel="bookmark" class="title">Malwarebytes安全更新如何导致错误地识别恶意软件</a>
					<div>
						不久前的4月15日,在Malwarebytes论坛上开始出现关于恶意软件检测问题的帖子.似乎突然间它将操作系统的一些部分文件还有它本身当做是恶意软件. C:WindowsSystem32SessEnv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6WAvz.html" rel="bookmark" class="title">IE9无法取消&OpenCurlyDoubleQuote;使用软件呈现而不使用GPU 呈现&rdquo;</a>
					<div>
						一.问题描述 在IE9中无法变更&quot;使用软件呈现而不使用 GPU 呈现&quot; 的设置. 二.方法 &quot;使用软件呈现而不使用 GPU 呈现&quot; 设定是开启,且呈现灰色无法变 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKk2KM.html" rel="bookmark" class="title">EXCEL中怎么输入&commat;字符？</a>
					<div>
						  1. 如图所示我们单元格输入&quot;@百度经验&quot;时,会出现错误提示对话框,提示无效. 2.而我们在单元格中输入&quot;@12&quot;,也同样的会出现错误提示,只是提示的对话框 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq83Gkb.html" rel="bookmark" class="title">如何改善网络连接</a>
					<div>
						  1.加快宽带接入速度 (1)家用版本:在[开始]--&gt;[运行]--&gt;键入[regedit]--&gt;在[HKEY_LOCAL_MACHINE]--&gt;[SOFTWARE]--&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwKZKb.html" rel="bookmark" class="title">云计算助力交通拥堵疏导</a>
					<div>
						近日,第二届中国云计算用户大会全国巡回研讨会在南京举行,多个行业的专家共同探讨基于云计算和大数据下的城市管理.记者从会上获悉,南京在交通管理.城市安防等领域已经与云计算和大数据深度融合,智能水平位于全 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badrYNz.html" rel="bookmark" class="title">全国助残日&comma;请给他们帮助别人的机会</a>
					<div>
						&quot;我是一名志愿者,我可以为您免费拍照,然后传到您的邮箱.&quot;刘鑫手里的便签纸上写着这样一串文字,他穿着绿色的志愿者马甲,背着一台单反相机. 当他拿着这张便签走近广场上一个卖气球的人, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YjBXM.html" rel="bookmark" class="title">mysql-navicat连接显示can&amp;amp&semi;amp&semi;&num;39&semi;t connect to Mysql Server</a>
					<div>
						问题描述 navicat连接显示can't connect to Mysql Server navicat连接显示can't connect to Mysql Server on 'localhost ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7Qoyp.html" rel="bookmark" class="title">&lbrack;Java开发之路&rsqb;Java字符串的10大热点问题盘点</a>
					<div>
						译文链接:http://www.html5tricks.com/10-top-questions-java-string.html英文原文:Top 10 questions of Java Strin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lLRxb.html" rel="bookmark" class="title">DockOne微信分享（一零三）：Kubernetes 有状态集群服务部署与管理</a>
					<div>
						本文讲的是DockOne微信分享(一零三):Kubernetes 有状态集群服务部署与管理[编者的话]本次分享将深入介绍Kubernetes如何满足有状态集群服务对容器编排系统提出的新需求,包括如何使 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrxXZM.html" rel="bookmark" class="title">EDAS伴侣ARMS终极进化：业务监控实时无边界</a>
					<div>
						作为和企业互联网架构平台 Apsara Aliware&quot;三驾马车&quot;(EDAS/DRDS/MQ)并驾齐驱的又一重磅产品.本文主要从ARMS的诞生背景开始,介绍了ARMS的雏形,着重说 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjAwep.html" rel="bookmark" class="title">两美元的&OpenCurlyDoubleQuote;听诊器&rdquo;，如何破解你的Apple Pay？&vert; 315特别报道</a>
					<div>
						       自从Apple Pay 推出以来,无数仁人志士前赴后继地试图破解它.虽然黑客们昼夜不休想要打苹果的脸,但是时至今日,苹果用&quot;绳命&quot;做背书的 Apple Pay 还没有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamXoNb.html" rel="bookmark" class="title">Redux 入门教程（一）：基本用法</a>
					<div>
						一年半前,我写了&lt;React 入门实例教程&gt;,介绍了 React 的基本用法. 但是,React 只是 DOM 的一个抽象层,并不是 Web 应用的完整解决方案.也就是说,只用 React ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4YKAz.html" rel="bookmark" class="title">加号实现快捷弹画面 （Shortcut&period;？），在线等，谢谢</a>
					<div>
						问题描述 F8的实现快捷弹画面是Shortcut.F8,加号是什,那位哥哥,姐姐知道. 解决方案 解决方案二:该回复于2012-04-11 08:35:47被版主删除解决方案三:在线等,急呀					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/M6ZwEJM.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAxMTMxMzA3Mjc2ODY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Wm5WNWFXWmhibWM9L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/M6ZwEJM.html" rel="bookmark" class="title">2014年博客之星评选，请大家多多支持</a>
					<div>
						我参加 了CSDN2014 博客之星大赛,请大家多多支持投我一票,谢谢. 参选理由:在技术的道路上,要学会学习和分享,不停追求,不停进步,直至完美.... 投票网址: http://vote.blog ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBml8b.html" rel="bookmark" class="title">Bootstrap &amp;lt&semi;基础二十六&amp;gt&semi;进度条</a>
					<div>
						原文:Bootstrap &lt;基础二十六&gt;进度条 Bootstrap 进度条.在本教程中,你将看到如何使用 Bootstrap 创建加载.重定向或动作状态的进度条. Bootstrap 进度 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7L4WM.html" rel="bookmark" class="title">sql内置函数pivot强大的行转列功能</a>
					<div>
						原文:sql内置函数pivot强大的行转列功能 语法: PIVOT用于将列值旋转为列名(即行转列),在SQL Server 2000可以用聚合函数配合CASE语句实现 PIVOT的一般语法是:PIVO ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkeRarb.html" rel="bookmark" class="title">IBM获5 nm芯片突破 手机续航提升2、3倍</a>
					<div>
						摩尔定律已死?IBM与其芯片合作伙伴Globalfoundries和三星可不同意. 日前,IBM宣布,三家研发了一种晶体管制造技术,将为5 nm芯片铺平道路.虽然团队所使用的芯片蚀刻技术与7 nm芯片 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ROjnz.html" rel="bookmark" class="title">深入JUnit源码之Runner</a>
					<div>
						初次用文字的方式记录读源码的过程,不知道怎么写,感觉有点贴代码的嫌疑.不过中间还是加入了一些自己的理解和心得,希望以后能够慢慢的改进,感兴趣的童鞋凑合着看吧,感觉JUnit这个框架还是值得看的,里面有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgQX4M.html" rel="bookmark" class="title">写给英语和数学都不怎么好的游戏开发爱好者</a>
					<div>
						[来信] 贺老师你好,我想学习C ,以后成为一名游戏开发员,可是我的英文和数学都不怎么好.我不知道该怎么办,从哪里学起,但是我确信这是我可以为之奋斗一生的事业. [回信] 你的来信,没有给我讲起你的专 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK51jEp.html" rel="bookmark" class="title">Informatica保障江苏电信规范化ETL开发</a>
					<div>
						文章讲的是Informatica保障江苏电信规范化ETL开发,Informatica产品帮助江苏电信构建起一个统一集中管理ETL平台,管理人员不需再维护EDA中多个系统的不同ETL平台,大大节约了运维 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLEy8M.html" rel="bookmark" class="title">mvc-MVC5中renderaction的问题i</a>
					<div>
						问题描述 MVC5中renderaction的问题i 主视图是一个同步视图,在主视图中 Html.RenderAction(&quot;RepositoriesList&quot;, &quot;Re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkngqM.html" rel="bookmark" class="title">数据中心内独享与共享技术</a>
					<div>
						数据中心里部署有各种各样的系统,其中数据处理系统是最为重要的部分,主要由服务器.网络.存储等设备组成,这里有各种资源,比如:带宽.计算能力.存储空间等,这些资源可以是共享的,也可以是独享的,具体要看是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyW4R4z.html" rel="bookmark" class="title">Avoision 0&period;7发布　街机模式游戏</a>
					<div>
						Avoision是一个简单的街机模式游戏.此游戏没有精彩的故事.华丽的图形和战斗,只是一个疯狂的,高速的游戏.游戏是由一个绿色方块左右箭头键移动来组成.游戏的目标是在时间用完之间捕捉到红色方块,同时避 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOnjJkp.html" rel="bookmark" class="title">python中xrange用法分析&lowbar;python</a>
					<div>
						本文实例讲述了python中xrange用法.分享给大家供大家参考.具体如下: 先来看如下示例: &gt;&gt;&gt; x=xrange(0,8) &gt;&gt;&gt; print x xra ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEY2knb.html" rel="bookmark" class="title">如何实现强制登录？&lowbar;编程10000问</a>
					<div>
						security.asp&lt;?xml:namespace prefix = o ns = &quot;urn:schemas-microsoft-com:office:office&quot; / ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0EDOp.html" rel="bookmark" class="title">一个奇怪的AJAX问题</a>
					<div>
						问题描述 我做了一个删除功能,删除后不刷新页面用JS刷新层里的内容就行.但是不知道为什么一删除就跳转回了首页.很郁闷.我哪也没有设置这个跳转.不过我在web.cml里设了一个session过滤器,se ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baq6Xnb.html" rel="bookmark" class="title">齐家网获百度投资</a>
					<div>
						国内最大的装修家居电子商务网站齐家网日前宣布,已获得百度投资,双方建立战略合作伙伴关系.齐家网(www.tg.com.cn)的前身是上海团购网,自2005年创办至今,已在全国28个城市开通分站.据艾瑞 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
